<template>
  <div>
    <div class="card">
        <div class="card-content">
                <h4 class="card-title">Declaraciones</h4>
                <div class="row">
                     <div class="col-md-4">
                        <label>Declaración </label><br>
                        <el-select  clearable class="select-default"
                        filterable
                        name="declaracion"
                        placeholder="Declaracion"
                        v-model="model.tipo_declaracion">
                            <el-option
                                v-for="option in tiposDeclaracion"
                                class="select-default"
                                :value="option.id"
                                :label="option.tipo_declaracion"
                                :key="option.tipo_declaracion">
                            </el-option>
                        </el-select>
                    </div>
                    <div v-if="rol!=4" class="col-md-4">
                        <label>Dependencia </label><br>
                        <el-select  clearable class="select-default"
                        filterable
                        name="dependencia"
                        placeholder="Dependencia"
                        v-model="model.dependencia_id">
                            <el-option
                                v-for="option in dependencias"
                                :value="option.id"
                                :label="option.valor"
                                :key="option.valor">
                            </el-option>
                        </el-select>
                    </div>
                    <div class="col-md-4">
                        <label>Año</label><br>
                        <el-select  clearable class="select-default"
                        filterable
                        name="periodo"
                        placeholder="Periodo"
                        v-model="model.periodo">
                            <el-option
                                v-for="option in periodos"
                                class="select-default"
                                :value="option.year"
                                :label="option.year"
                                :key="option.year">
                            </el-option>
                        </el-select>
                    </div>


                </div>
                <br>
                <button @click="getDeclaraciones" class="btn btn-fill btn-success pull-right">
                        Buscar
                </button>
                <br><br><br>

            <div v-if="true">
                <br>
                <div class="row">
                    <div class="col-sm-6">
                        <el-select
                            class="select-default"
                            v-model="pagination.perPage"
                            placeholder="Per page">
                            <el-option
                            class="select-default"
                            v-for="item in pagination.perPageOptions"
                            :key="item"
                            :label="item"
                            :value="item">
                            </el-option>
                        </el-select>
                    </div>
                    <div class="col-sm-6">
                        <div class="pull-right">
                        <label>
                            <input type="search" class="form-control input-sm" placeholder="Buscar" v-model="searchQuery" aria-controls="datatables">
                        </label>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 col-md-12 col-lg-12">
                    <el-table class="table-striped table-responsive"
                                    :data="queriedData"
                                    border
                                    style="width: 100%">
                            <el-table-column
                            fixed="right"
                            :min-width="75"
                            label="Acciones">
                                <template slot-scope="props">
                                    <a class="btn btn-simple btn-xs btn-success btn-icon delete" @click="descargar(props.row)"><i class="ti-download"></i></a>
                                    <a class="btn btn-simple btn-xs btn-danger btn-icon delete" @click="reactivar(props.row)"><i class="ti-check"></i></a>
                                </template>
                            </el-table-column>
                            <el-table-column v-for="column in tableColumns"
                                            :key="column.label"
                                            :min-width="column.minWidth"
                                            :prop="column.prop"
                                            :label="column.label"
                                            :v-if="column.vif"
                                            >
                            </el-table-column>
                        </el-table>
                    </div>
                </div>
                <div class="col-sm-6 pagination-info">
                    <p class="category">Mostrando {{from + 1}} a {{to}} de {{total}} registros</p>
                </div>
                <div class="col-sm-6">
                    <p-pagination class="pull-right"
                                    v-model="pagination.currentPage"
                                    :per-page="pagination.perPage"
                                    :total="pagination.total">
                    </p-pagination>
                </div>
            </div>


        </div>
    </div>

 </div>
</template>
<script>
  import Vue from 'vue'
  import {Table, TableColumn, Select, Option} from 'element-ui'
  import PPagination from 'src/components/UIComponents/Pagination.vue'

  Vue.use(Table)
  Vue.use(TableColumn)
  Vue.use(Select)
  Vue.use(Option)

  export default {
    components: {
      PPagination
    },
    /**
     * Chart data used to render stats, charts. Should be replaced with server data
     */
    data () {
      return {
        model:{tipo_declaracion:'',dependencia_id:'',periodo:''},
        dependencias:{},
        rol:'',
        periodos:[],
        mostrar:false,
        tiposDeclaracion:[],
        list_cumplimiento:[],
        pagination: {
          perPage: 5,
          currentPage: 1,
          perPageOptions: [5, 10, 25, 50],
          total: 0
        },
        searchQuery: '',
        propsToSearch: ['rfc', 'nombre'],
        tableColumns: [ { prop: 'id', label: 'Dec', minWidth: 150, vif:false  },
                        { prop: 'rfc', label: 'RFC', minWidth: 150, vif:true },
                        { prop: 'nombres',label: 'Nombre',minWidth: 100, vif:true }]
      }
    },
    computed: {
      pagedData () {
        return this.list_cumplimiento.slice(this.from, this.to)
      },
      /***
       * Searches through table data and returns a paginated array.
       * Note that this should not be used for table with a lot of data as it might be slow!
       * Do the search and the pagination on the server and display the data retrieved from server instead.
       * @returns {computed.pagedData}
       */
      queriedData () {
        if (!this.searchQuery) {
          this.pagination.total = this.list_cumplimiento.length
          return this.pagedData
        }
        let result = this.list_cumplimiento
          .filter((row) => {
            let isIncluded = false
            for (let key of this.propsToSearch) {
              let rowValue = row[key].toString()
              if (rowValue.includes && rowValue.includes(this.searchQuery)) {
                isIncluded = true
              }
            }
            return isIncluded
          })
        this.pagination.total = result.length
        return result.slice(this.from, this.to)
      },
      to () {
        let highBound = this.from + this.pagination.perPage
        if (this.total < highBound) {
          highBound = this.total
        }
        return highBound
      },
      from () {
        return this.pagination.perPage * (this.pagination.currentPage - 1)
      },
      total () {
        this.pagination.total = this.list_cumplimiento.length
        return this.list_cumplimiento.length
      }
    },
    created(){
        this.getDependencias();
        this.getTipoDeclaracion();
        this.getPeriodos();
        this.rol = this.getKey('role');
    },
    methods:{
        getDependencias(){
        var v = this;
        this.$http.get("cat_ente_publico").then(
            response => {
                this.dependencias = response.data.entes_publicos;
            },
            error => {
                this.StepError(error);
            }
        );
        },
        getTipoDeclaracion(){
        var v = this;
        this.$http.get("tiposDeclaracion").then(
            response => {
            this.tiposDeclaracion = response.data.tipoDeclaracion;
            },
             error => {
            this.StepError(error);
            }
        );
        },
        getPeriodos(){
        var v = this;
        this.$http.get("getPeriodos").then(
            response => {
            this.periodos = response.data.periodos;
            },
             error => {
            this.StepError(error);
            }
        );
        },
        getDeclaraciones(){

            if(this.rol==4)
                this.model.dependencia_id = this.getKey('ente_publico_id')

            this.$http.get("declaraciones/"+this.model.tipo_declaracion+'/'+this.model.dependencia_id+'/'+this.model.periodo).then(
                response => {
                    this.mostrar = true;
                    var v = this;
                    v.list_cumplimiento = [];

                     $.each(response.data.declarantes, function(key, value) {
                     v.list_cumplimiento.push({ 'id':       value.decid,
                                                'rfc':      value.rfc,
                                                'nombres':  value.nombres+' '+value.primer_apellido+' '+value.segundo_apellido
                                             });

                     });
                },
                error => {
                this.StepError(error);
                }
            );
        },
        descargar(row){
            const token = this.$jwt.getToken();
            const auth = 'Bearer ' + (token ? token.hash : "");
            var url = [this.$http.options.root + 'getDeclaracion/pdf/' +row.id];
            window.open(url, '_blank');
        },
        reactivar(row){
          this.Ask("¿Desea reactivar ésta declaración?", () => {

             this.$http.get("declaracion/reactiva/"+row.id).then(
                response => {
                     console.log("ok")
                },
                error => {
                this.StepError(error);
                }
            );
          });
        }
    }
  }

</script>